// Code generated by go-swagger; DO NOT EDIT.

package users

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// UserDeleteHandlerFunc turns a function with the right signature into a user delete handler
type UserDeleteHandlerFunc func(UserDeleteParams) middleware.Responder

// Handle executing the request and returning a response
func (fn UserDeleteHandlerFunc) Handle(params UserDeleteParams) middleware.Responder {
	return fn(params)
}

// UserDeleteHandler interface for that can handle valid user delete params
type UserDeleteHandler interface {
	Handle(UserDeleteParams) middleware.Responder
}

// NewUserDelete creates a new http.Handler for the user delete operation
func NewUserDelete(ctx *middleware.Context, handler UserDeleteHandler) *UserDelete {
	return &UserDelete{Context: ctx, Handler: handler}
}

/*UserDelete swagger:route DELETE /api/users/{id} Users userDelete

Delete user

*/
type UserDelete struct {
	Context *middleware.Context
	Handler UserDeleteHandler
}

func (o *UserDelete) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUserDeleteParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
